From dde8a9d98d19092b6b5e3f5a86c6f80c22b9c332 Mon Sep 17 00:00:00 2001
From: Sylvain Munaut <tnt@246tNt.com>
Date: Thu, 24 Sep 2009 01:56:00 +0200
Subject: [PATCH 5/5] HACK TO TEST CIPHERED SMS DELIVERY IN A5/2

Change the SRES & Kc to your params.
You might need to change A5/2 to A5/1 for modern
handsets.
---
 openbsc/include/openbsc/gsm_04_08.h |    5 +++++
 openbsc/src/gsm_04_08.c             |   35 ++++++++++++++++++++++++++++++++++-
 2 files changed, 39 insertions(+), 1 deletions(-)

diff --git a/openbsc/include/openbsc/gsm_04_08.h b/openbsc/include/openbsc/gsm_04_08.h
index acca100..7bbe2c1 100644
--- a/openbsc/include/openbsc/gsm_04_08.h
+++ b/openbsc/include/openbsc/gsm_04_08.h
@@ -85,6 +85,11 @@ struct gsm48_auth_req {
 	u_int8_t rand[16];
 } __attribute__ ((packed));
 
+/* Section 9.2.3 */
+struct gsm48_auth_resp {
+	u_int8_t sres[4];
+} __attribute__ ((packed));
+
 /* Section 9.2.15 */
 struct gsm48_loc_upd_req {
 	u_int8_t type:4,
diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index 826ae6a..d8c4354 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -295,6 +295,12 @@ static int gsm0408_authorize(struct gsm_lchan *lchan, struct msgb *msg)
 
 	if (authorize_subscriber(lchan->loc_operation, lchan->subscr)) {
 		int rc;
+		u_int8_t rand[16] = {
+			0xff, 0xff, 0xff, 0xff,
+			0xff, 0xff, 0xff, 0xff,
+			0xff, 0xff, 0xff, 0xff,
+			0xff, 0xff, 0xff, 0xff,
+		};
 
 		db_subscriber_alloc_tmsi(lchan->subscr);
 		tmsi = strtoul(lchan->subscr->tmsi, NULL, 10);
@@ -305,6 +311,7 @@ static int gsm0408_authorize(struct gsm_lchan *lchan, struct msgb *msg)
 		 * trigger further action like SMS delivery */
 		subscr_update(lchan->subscr, msg->trx->bts,
 			      GSM_SUBSCRIBER_UPDATE_ATTACHED);
+		gsm48_tx_mm_auth_req(lchan, rand);
 		return rc;
 	}
 
@@ -1088,6 +1095,26 @@ static int mm_rx_loc_upd_req(struct msgb *msg)
 	return gsm0408_authorize(lchan, msg);
 }
 
+static int mm_rx_auth_resp(struct msgb *msg)
+{
+	struct gsm48_hdr *gh = msgb_l3(msg);
+	struct gsm48_auth_resp *ar;
+	struct gsm_lchan *lchan = msg->lchan;
+	int i;
+
+ 	ar = (struct gsm48_auth_resp *) gh->data;
+
+	for (i=0; i<4; i++)
+		DEBUGPC(DMM, "%02x ", ar->sres[i]);
+	DEBUGPC(DMM, "\n");
+
+		/* FIXME hardcoded response */
+	if (memcmp(ar->sres, "\xa5\x97\x5e\x88", 4))
+		return gsm48_tx_mm_auth_rej(lchan);
+
+	return 0;
+}
+
 /* 9.1.5 Channel mode modify: Modify the mode on the MS side */
 int gsm48_tx_chan_mode_modify(struct gsm_lchan *lchan, u_int8_t mode)
 {
@@ -1462,7 +1489,8 @@ static int gsm0408_rcv_mm(struct msgb *msg)
 		DEBUGP(DMM, "CM REESTABLISH REQUEST: Not implemented\n");
 		break;
 	case GSM48_MT_MM_AUTH_RESP:
-		DEBUGP(DMM, "AUTHENTICATION RESPONSE: Not implemented\n");
+		DEBUGP(DMM, "AUTHENTICATION RESPONSE: ");
+		rc = mm_rx_auth_resp(msg);
 		break;
 	default:
 		fprintf(stderr, "Unknown GSM 04.08 MM msg type 0x%02x\n",
@@ -1538,6 +1566,11 @@ static int gsm48_rr_rx_pag_resp(struct msgb *msg)
 	/* FIXME: somehow signal the completion of the PAGING to
 	 * the entity that requested the paging */
 
+	msg->lchan->encr.alg_id = RSL_ENC_ALG_A5(2);
+	msg->lchan->encr.key_len = 8;
+	memcpy(msg->lchan->encr.key, "\xE0\x94\x0F\xC0\x9A\xEF\xA0\x00", 8);
+	gsm48_send_rr_ciph_mode(msg->lchan);
+
 	return rc;
 }
 
-- 
1.6.4

